#!/usr/bin/env python

"""
A Python module to be used via cron to monitor a Zope installation,
and (re)start it if it has died, or is running but non-responsive

Written by willdawg (willd@p-wave.com) March, 2001
Licensed under the BSD License

This program uses the "timeoutsocket.py" module, which can be found
at http://www.vex.net/parnassus/
"""

import timeoutsocket, os, httplib, syslog

timeoutsocket.setDefaultSocketTimeout(30)

###################################################################
# Please change these options to fit your site --
###################################################################
#
# Where the Python executable lives that you want to use to run Zope:
zopeswbase = '/your/zope/path/bin/'
#
# Where your Zope installation lives (location of z2.py):
zopeinst = '/home/zope/instance/'
#
# Optional arguments to pass to z2.py:
zopeargs = '-p "" -m ""'
#
# The address of your site:
sitename = 'www.yourcompany.com'
#
# Socket timeout value:
stimeout = 10
#
##################################################################

def startzope():
	startstat = os.system(zopeswbase + 'python ' \
	+ zopeinst + 'z2.py ' + zopeargs)
	if startstat != 0:
		print 'Start failed!', '(' + str(startstat) + ')'
	else:
		print 'Zope instance started.', '(' + str(startstat) + ')'

def stopzope():
	global stopstat
	stopstat = os.system(zopeinst + 'stop')
	if stopstat != 0:
		print 'Stop failed!', '(' + str(stopstat) + ')'
	else:
		print 'Zope instance stopped.', '(' + str(stopstat) + ')'

#
# Check the site and do the right thing --
#

try:
	h = httplib.HTTP(sitename)
	h.sock.set_timeout(stimeout)
	h.putrequest('GET', '/')
	h.putheader('Accept', 'text/html')
	h.putheader('Accept', 'text/plain')
	h.endheaders()
	errcode, errmsg, headers = h.getreply()

except timeoutsocket.Timeout:
	print 'Timed out! Restarting server...'
	stopzope()
	if stopstat == 0:
		startzope()
		syslog.syslog('ZOPE RUNNING BUT HUNG: %s; Zope restarted' % sitename)
	else:
		print 'Since stop failed, could not restart Zope.'

except:
	# TODO: Need logic to control whether to start Zope or not depending on if Zope stopped on purpose
	print 'Not listening! Starting server...'
	startzope()
	syslog.syslog('ZOPE NOT RUNNING: %s; Zope was started' % sitename)

else:
	pass
	#print 'Zope server responded, response was:', errcode, errmsg
